Index: trunk/source/processes/hadronic/models/neutron_hp/include/G4NeutronHPPTInelasticFS.hh
===================================================================
--- trunk/source/processes/hadronic/models/neutron_hp/include/G4NeutronHPPTInelasticFS.hh	(revision 819)
+++ trunk/source/processes/hadronic/models/neutron_hp/include/G4NeutronHPPTInelasticFS.hh	(revision 962)
@@ -26,5 +26,5 @@
 //
 // $Id: G4NeutronHPPTInelasticFS.hh,v 1.9 2006/06/29 20:49:13 gunter Exp $
-// GEANT4 tag $Name:  $
+// GEANT4 tag $Name: geant4-09-02-ref-02 $
 //
 #ifndef G4NeutronHPPTInelasticFS_h
Index: trunk/source/processes/hadronic/models/neutron_hp/include/G4NeutronHPPartial.hh
===================================================================
--- trunk/source/processes/hadronic/models/neutron_hp/include/G4NeutronHPPartial.hh	(revision 819)
+++ trunk/source/processes/hadronic/models/neutron_hp/include/G4NeutronHPPartial.hh	(revision 962)
@@ -26,5 +26,5 @@
 //
 // $Id: G4NeutronHPPartial.hh,v 1.13 2007/06/18 20:56:05 tkoi Exp $
-// GEANT4 tag $Name:  $
+// GEANT4 tag $Name: geant4-09-02-ref-02 $
 //
 // 070618 Comment out unused private member leaking by T. Koi
Index: trunk/source/processes/hadronic/models/neutron_hp/include/G4NeutronHPPhotonDist.hh
===================================================================
--- trunk/source/processes/hadronic/models/neutron_hp/include/G4NeutronHPPhotonDist.hh	(revision 819)
+++ trunk/source/processes/hadronic/models/neutron_hp/include/G4NeutronHPPhotonDist.hh	(revision 962)
@@ -25,6 +25,6 @@
 //
 //
-// $Id: G4NeutronHPPhotonDist.hh,v 1.16 2007/06/22 09:23:47 gcosmo Exp $
-// GEANT4 tag $Name:  $
+// $Id: G4NeutronHPPhotonDist.hh,v 1.17 2008/06/26 02:40:23 tkoi Exp $
+// GEANT4 tag $Name: geant4-09-02-ref-02 $
 //
  // Hadronic Process: Very Low Energy Neutron X-Sections
@@ -34,4 +34,5 @@
 // 070612 fix memory leaking by T. Koi
 // 070615 fix memory leaking by T. Koi
+// 080625 fix memory leaking by T. Koi
 //
  
@@ -102,18 +103,23 @@
      delete [] theGammas;
      delete [] nNeu;
-     delete [] theLegendre;
      delete [] theAngular;
      delete [] distribution;
      delete [] probs;
 
-// TKDB
+     if ( theLegendre != NULL )
+     {
+        for ( G4int i = 0 ; i < (nDiscrete2-nIso) ; i++ )
+           if ( theLegendre[i] != NULL ) delete[] theLegendre[i]; 
+
+        delete [] theLegendre;
+     }
+
      if ( partials != 0 ) 
      {
         for ( G4int i = 0 ; i < nPartials ; i++ )
-           { delete partials[ i ]; }
+           { delete partials[i]; }
 
         delete [] partials;
      }
-     // delete [] partials;
 
      delete [] actualMult;
Index: trunk/source/processes/hadronic/models/neutron_hp/include/G4NeutronHPPhotonXSection.hh
===================================================================
--- trunk/source/processes/hadronic/models/neutron_hp/include/G4NeutronHPPhotonXSection.hh	(revision 819)
+++ trunk/source/processes/hadronic/models/neutron_hp/include/G4NeutronHPPhotonXSection.hh	(revision 962)
@@ -26,5 +26,5 @@
 //
 // $Id: G4NeutronHPPhotonXSection.hh,v 1.11 2007/06/06 12:45:13 ahoward Exp $
-// GEANT4 tag $Name:  $
+// GEANT4 tag $Name: geant4-09-02-ref-02 $
 //
 #ifndef G4NeutronHPPhotonXSection_h
Index: trunk/source/processes/hadronic/models/neutron_hp/include/G4NeutronHPPolynomExpansion.hh
===================================================================
--- trunk/source/processes/hadronic/models/neutron_hp/include/G4NeutronHPPolynomExpansion.hh	(revision 819)
+++ trunk/source/processes/hadronic/models/neutron_hp/include/G4NeutronHPPolynomExpansion.hh	(revision 962)
@@ -26,5 +26,5 @@
 //
 // $Id: G4NeutronHPPolynomExpansion.hh,v 1.11 2007/06/06 12:45:13 ahoward Exp $
-// GEANT4 tag $Name:  $
+// GEANT4 tag $Name: geant4-09-02-ref-02 $
 //
 #ifndef G4NeutronHPPolynomExpansion_h
Index: trunk/source/processes/hadronic/models/neutron_hp/include/G4NeutronHPProduct.hh
===================================================================
--- trunk/source/processes/hadronic/models/neutron_hp/include/G4NeutronHPProduct.hh	(revision 819)
+++ trunk/source/processes/hadronic/models/neutron_hp/include/G4NeutronHPProduct.hh	(revision 962)
@@ -26,5 +26,5 @@
 //
 // $Id: G4NeutronHPProduct.hh,v 1.12 2007/06/06 12:45:13 ahoward Exp $
-// GEANT4 tag $Name:  $
+// GEANT4 tag $Name: geant4-09-02-ref-02 $
 //
 #ifndef G4NeutronHPProduct_h
Index: trunk/source/processes/hadronic/models/neutron_hp/include/G4NeutronHPSCFissionFS.hh
===================================================================
--- trunk/source/processes/hadronic/models/neutron_hp/include/G4NeutronHPSCFissionFS.hh	(revision 819)
+++ trunk/source/processes/hadronic/models/neutron_hp/include/G4NeutronHPSCFissionFS.hh	(revision 962)
@@ -26,5 +26,5 @@
 //
 // $Id: G4NeutronHPSCFissionFS.hh,v 1.11 2007/06/06 12:45:13 ahoward Exp $
-// GEANT4 tag $Name:  $
+// GEANT4 tag $Name: geant4-09-02-ref-02 $
 //
 #ifndef G4NeutronHPSCFissionFS_h
Index: trunk/source/processes/hadronic/models/neutron_hp/include/G4NeutronHPSimpleEvapSpectrum.hh
===================================================================
--- trunk/source/processes/hadronic/models/neutron_hp/include/G4NeutronHPSimpleEvapSpectrum.hh	(revision 819)
+++ trunk/source/processes/hadronic/models/neutron_hp/include/G4NeutronHPSimpleEvapSpectrum.hh	(revision 962)
@@ -26,5 +26,5 @@
 //
 // $Id: G4NeutronHPSimpleEvapSpectrum.hh,v 1.11 2006/06/29 20:49:27 gunter Exp $
-// GEANT4 tag $Name:  $
+// GEANT4 tag $Name: geant4-09-02-ref-02 $
 //
 #ifndef G4NeutronHPSimpleEvapSpectrum_h
Index: trunk/source/processes/hadronic/models/neutron_hp/include/G4NeutronHPT2AInelasticFS.hh
===================================================================
--- trunk/source/processes/hadronic/models/neutron_hp/include/G4NeutronHPT2AInelasticFS.hh	(revision 819)
+++ trunk/source/processes/hadronic/models/neutron_hp/include/G4NeutronHPT2AInelasticFS.hh	(revision 962)
@@ -26,5 +26,5 @@
 //
 // $Id: G4NeutronHPT2AInelasticFS.hh,v 1.9 2006/06/29 20:49:29 gunter Exp $
-// GEANT4 tag $Name:  $
+// GEANT4 tag $Name: geant4-09-02-ref-02 $
 //
 #ifndef G4NeutronHPT2AInelasticFS_h
Index: trunk/source/processes/hadronic/models/neutron_hp/include/G4NeutronHPTCFissionFS.hh
===================================================================
--- trunk/source/processes/hadronic/models/neutron_hp/include/G4NeutronHPTCFissionFS.hh	(revision 819)
+++ trunk/source/processes/hadronic/models/neutron_hp/include/G4NeutronHPTCFissionFS.hh	(revision 962)
@@ -26,5 +26,5 @@
 //
 // $Id: G4NeutronHPTCFissionFS.hh,v 1.11 2007/06/06 12:45:13 ahoward Exp $
-// GEANT4 tag $Name:  $
+// GEANT4 tag $Name: geant4-09-02-ref-02 $
 //
 #ifndef G4NeutronHPTCFissionFS_h
Index: trunk/source/processes/hadronic/models/neutron_hp/include/G4NeutronHPTInelasticFS.hh
===================================================================
--- trunk/source/processes/hadronic/models/neutron_hp/include/G4NeutronHPTInelasticFS.hh	(revision 819)
+++ trunk/source/processes/hadronic/models/neutron_hp/include/G4NeutronHPTInelasticFS.hh	(revision 962)
@@ -26,5 +26,5 @@
 //
 // $Id: G4NeutronHPTInelasticFS.hh,v 1.9 2006/06/29 20:49:33 gunter Exp $
-// GEANT4 tag $Name:  $
+// GEANT4 tag $Name: geant4-09-02-ref-02 $
 //
 #ifndef G4NeutronHPTInelasticFS_h
Index: trunk/source/processes/hadronic/models/neutron_hp/include/G4NeutronHPThermalBoost.hh
===================================================================
--- trunk/source/processes/hadronic/models/neutron_hp/include/G4NeutronHPThermalBoost.hh	(revision 819)
+++ trunk/source/processes/hadronic/models/neutron_hp/include/G4NeutronHPThermalBoost.hh	(revision 962)
@@ -24,4 +24,6 @@
 // ********************************************************************
 //
+// 081024 G4NucleiPropertiesTable:: to G4NucleiProperties::
+//
 #ifndef G4NeutronHPThermalBoost_h
 #define G4NeutronHPThermalBoost_h
@@ -31,5 +33,5 @@
 #include "G4ReactionProduct.hh"
 #include "G4Nucleus.hh"
-#include "G4NucleiPropertiesTable.hh"
+#include "G4NucleiProperties.hh"
 #include "G4Electron.hh"
 #include "G4Neutron.hh"
@@ -62,6 +64,5 @@
     G4double eps = 0.0001;
     G4double eleMass; 
-    eleMass = ( G4NucleiPropertiesTable::GetNuclearMass(static_cast<G4int>(theZ+eps), static_cast<G4int>(theA+eps))
-  	       ) / G4Neutron::Neutron()->GetPDGMass();
+    eleMass = ( G4NucleiProperties::GetNuclearMass( static_cast<G4int>(theA+eps) , static_cast<G4int>(theZ+eps) ) ) / G4Neutron::Neutron()->GetPDGMass();
   
     G4ReactionProduct aThermalNuc = aNuc.GetBiasedThermalNucleus(eleMass, neuVelo, aT);
Index: trunk/source/processes/hadronic/models/neutron_hp/include/G4NeutronHPVector.hh
===================================================================
--- trunk/source/processes/hadronic/models/neutron_hp/include/G4NeutronHPVector.hh	(revision 819)
+++ trunk/source/processes/hadronic/models/neutron_hp/include/G4NeutronHPVector.hh	(revision 962)
@@ -26,4 +26,6 @@
 // 070606 fix with Valgrind by T. Koi
 // 080409 Fix div0 error with G4FPE by T. Koi
+// 080811 Comment out unused method SetBlocked and SetBuffered
+//        Add required cleaning up in CleanUp by T. Koi
 //
 #ifndef G4NeutronHPVector_h
@@ -253,4 +255,7 @@
     maxValue = -DBL_MAX;
     theHash.Clear();
+//080811 TK DB 
+    delete[] theIntegral;
+    theIntegral = NULL;
   }
 
@@ -491,4 +496,5 @@
   }
   
+/*
   void Block(G4double aX)
   {
@@ -500,10 +506,11 @@
     theBuffered.push_back(aX);
   }
+*/
   
   std::vector<G4double> GetBlocked() {return theBlocked;}
   std::vector<G4double> GetBuffered() {return theBuffered;}
   
-  void SetBlocked(const std::vector<G4double> &aBlocked) {theBlocked = aBlocked;}
-  void SetBuffered(const std::vector<G4double> &aBuffer) {theBuffered = aBuffer;}
+//  void SetBlocked(const std::vector<G4double> &aBlocked) {theBlocked = aBlocked;}
+//  void SetBuffered(const std::vector<G4double> &aBuffer) {theBuffered = aBuffer;}
 
   G4double Get15percentBorder();
Index: trunk/source/processes/hadronic/models/neutron_hp/include/G4NeutronHPWattSpectrum.hh
===================================================================
--- trunk/source/processes/hadronic/models/neutron_hp/include/G4NeutronHPWattSpectrum.hh	(revision 819)
+++ trunk/source/processes/hadronic/models/neutron_hp/include/G4NeutronHPWattSpectrum.hh	(revision 962)
@@ -26,5 +26,5 @@
 //
 // $Id: G4NeutronHPWattSpectrum.hh,v 1.11 2006/06/29 20:49:39 gunter Exp $
-// GEANT4 tag $Name:  $
+// GEANT4 tag $Name: geant4-09-02-ref-02 $
 //
 #ifndef G4NeutronHPWattSpectrum_h
Index: trunk/source/processes/hadronic/models/neutron_hp/include/G4VNeutronHPEDis.hh
===================================================================
--- trunk/source/processes/hadronic/models/neutron_hp/include/G4VNeutronHPEDis.hh	(revision 819)
+++ trunk/source/processes/hadronic/models/neutron_hp/include/G4VNeutronHPEDis.hh	(revision 962)
@@ -26,5 +26,5 @@
 //
 // $Id: G4VNeutronHPEDis.hh,v 1.10 2006/06/29 20:50:05 gunter Exp $
-// GEANT4 tag $Name:  $
+// GEANT4 tag $Name: geant4-09-02-ref-02 $
 //
 #ifndef G4VNeutronHPEDis_h
Index: trunk/source/processes/hadronic/models/neutron_hp/include/G4VNeutronHPEnergyAngular.hh
===================================================================
--- trunk/source/processes/hadronic/models/neutron_hp/include/G4VNeutronHPEnergyAngular.hh	(revision 819)
+++ trunk/source/processes/hadronic/models/neutron_hp/include/G4VNeutronHPEnergyAngular.hh	(revision 962)
@@ -25,6 +25,8 @@
 //
 //
-// $Id: G4VNeutronHPEnergyAngular.hh,v 1.11 2007/06/06 12:45:13 ahoward Exp $
-// GEANT4 tag $Name:  $
+// $Id: G4VNeutronHPEnergyAngular.hh,v 1.12 2008/07/21 23:26:29 tkoi Exp $
+// GEANT4 tag $Name: geant4-09-02-ref-02 $
+//
+// 080718 Add ClearHistories() method by T. Koi
 //
 #ifndef G4VNeutronHPEnergyAngular_h
@@ -87,4 +89,6 @@
   G4ReactionProduct theCMS;
     
+   public:
+      virtual void ClearHistories(){;};
 };
 #endif
Index: trunk/source/processes/hadronic/models/neutron_hp/src/G4NeutronHPAngular.cc
===================================================================
--- trunk/source/processes/hadronic/models/neutron_hp/src/G4NeutronHPAngular.cc	(revision 819)
+++ trunk/source/processes/hadronic/models/neutron_hp/src/G4NeutronHPAngular.cc	(revision 962)
@@ -29,4 +29,5 @@
 //
 // 070523 bug fix for G4FPE_DEBUG on by A. Howard ( and T. Koi)
+// 080612 bug fix contribution from Benoit Pirard and Laurent Desorgher (Univ. Bern) #5
 //
 #include "G4NeutronHPAngular.hh"
@@ -106,4 +107,31 @@
   else
   {
+    if(frameFlag == 1) // LAB
+    {
+      G4double en = aHadron.GetTotalMomentum();
+      G4ReactionProduct boosted;
+      boosted.Lorentz(theNeutron, theTarget);
+      G4double kineticEnergy = boosted.GetKineticEnergy();
+      G4double cosTh = 0.0; 
+      if(theAngularDistributionType == 1) cosTh = theCoefficients->SampleMax(kineticEnergy); 
+      if(theAngularDistributionType == 2) cosTh = theProbArray->Sample(kineticEnergy); 
+      G4double theta = std::acos(cosTh);
+      G4double phi = twopi*G4UniformRand();
+      G4double sinth = std::sin(theta);
+      G4ThreeVector temp(en*sinth*std::cos(phi), en*sinth*std::sin(phi), en*std::cos(theta) );
+      aHadron.SetMomentum( temp );
+    }
+    else if(frameFlag == 2) // costh in CMS
+    {
+      G4ReactionProduct boostedN;
+      boostedN.Lorentz(theNeutron, theTarget);
+      G4double kineticEnergy = boostedN.GetKineticEnergy();
+
+      G4double cosTh = 0.0; 
+      if(theAngularDistributionType == 1) cosTh = theCoefficients->SampleMax(kineticEnergy); 
+      if(theAngularDistributionType == 2) cosTh = theProbArray->Sample(kineticEnergy); 
+
+//080612TK bug fix contribution from Benoit Pirard and Laurent Desorgher (Univ. Bern) 
+/*
     if(theAngularDistributionType == 1) // LAB
     {
@@ -121,8 +149,11 @@
     else if(theAngularDistributionType == 2) // costh in CMS
     {
-      G4ReactionProduct boostedN;
-      boostedN.Lorentz(theNeutron, theTarget);
-      G4double kineticEnergy = boostedN.GetKineticEnergy();
-      G4double cosTh = theProbArray->Sample(kineticEnergy); 
+*/
+
+//      G4ReactionProduct boostedN;
+//      boostedN.Lorentz(theNeutron, theTarget);
+//      G4double kineticEnergy = boostedN.GetKineticEnergy();
+//      G4double cosTh = theProbArray->Sample(kineticEnergy); 
+
       G4double theta = std::acos(cosTh);
       G4double phi = twopi*G4UniformRand();
@@ -130,4 +161,7 @@
       
       G4ThreeVector temp(sinth*std::cos(phi), sinth*std::sin(phi), std::cos(theta) ); //CMS
+
+//080612TK bug fix contribution from Benoit Pirard and Laurent Desorgher (Univ. Bern) #5
+/*
       G4double en = aHadron.GetTotalEnergy(); // Target rest
       
@@ -172,4 +206,40 @@
       aHadron.SetTotalEnergy( std::sqrt( mom*mom + aHadron.GetMass()*aHadron.GetMass() ) );
       aHadron.Lorentz(aHadron, trafo); // now in target rest frame
+*/
+      // Determination of the hadron kinetic energy in CMS
+      // aHadron.GetKineticEnergy() is actually the residual kinetic energy in CMS (or target frame)
+      // kineticEnergy is incident neutron kinetic energy  in CMS (or target frame)  
+      G4double QValue = aHadron.GetKineticEnergy() - kineticEnergy;
+      G4double A1     =   theTarget.GetMass()/boostedN.GetMass(); 
+      G4double A1prim =   aHadron.GetMass()/ boostedN.GetMass();
+      G4double kinE   = (A1+1-A1prim)/(A1+1)/(A1+1)*(A1*kineticEnergy+(1+A1)*QValue);
+      G4double totalE = kinE + aHadron.GetMass();
+      G4double mom2   = totalE*totalE - aHadron.GetMass()*aHadron.GetMass();
+      G4double mom;
+      if ( mom2 > 0.0 ) mom = std::sqrt( mom2 );
+      else mom = 0.0;     
+
+      aHadron.SetMomentum( mom*temp ); // Set momentum in CMS
+      aHadron.SetKineticEnergy(kinE);  // Set kinetic energy in CMS
+
+      // get trafo from Target rest frame to CMS
+      G4ReactionProduct boostedT;
+      boostedT.Lorentz(theTarget, theTarget);
+      
+      G4ThreeVector the3Neutron = boostedN.GetMomentum();
+      G4double nEnergy = boostedN.GetTotalEnergy();
+      G4ThreeVector the3Target = boostedT.GetMomentum();
+      G4double tEnergy = boostedT.GetTotalEnergy();
+      G4double totE = nEnergy+tEnergy;
+      G4ThreeVector the3trafo = -the3Target-the3Neutron;
+      G4ReactionProduct trafo; // for transformation from CMS to target rest frame
+      trafo.SetMomentum(the3trafo);
+      G4double cmsMom = std::sqrt(the3trafo*the3trafo);
+      G4double sqrts = std::sqrt((totE-cmsMom)*(totE+cmsMom));
+      trafo.SetMass(sqrts);
+      trafo.SetTotalEnergy(totE);
+
+      aHadron.Lorentz(aHadron, trafo);
+
     }
     else
Index: trunk/source/processes/hadronic/models/neutron_hp/src/G4NeutronHPCaptureData.cc
===================================================================
--- trunk/source/processes/hadronic/models/neutron_hp/src/G4NeutronHPCaptureData.cc	(revision 819)
+++ trunk/source/processes/hadronic/models/neutron_hp/src/G4NeutronHPCaptureData.cc	(revision 962)
@@ -31,4 +31,7 @@
 // 070613 fix memory leaking by T. Koi
 // 071002 enable cross section dump by T. Koi
+// 080428 change checking point of "neglecting doppler broadening" flag 
+//        from GetCrossSection to BuildPhysicsTable by T. Koi
+// 081024 G4NucleiPropertiesTable:: to G4NucleiProperties::
 //
 #include "G4NeutronHPCaptureData.hh"
@@ -49,4 +52,5 @@
 // TKDB
    theCrossSections = 0;
+   onFlightDB = true;
   BuildPhysicsTable(*G4Neutron::Neutron());
 }
@@ -65,4 +69,8 @@
   if(&aP!=G4Neutron::Neutron()) 
      throw G4HadronicException(__FILE__, __LINE__, "Attempt to use NeutronHP data for particles other than neutrons!!!");  
+
+//080428
+   if ( getenv( "G4NEUTRONHP_NEGLECT_DOPPLER" ) ) onFlightDB = false;
+
   size_t numberOfElements = G4Element::GetNumberOfElements();
   // G4cout << "CALLED G4NeutronHPCaptureData::BuildPhysicsTable "<<numberOfElements<<G4endl;
@@ -136,5 +144,5 @@
 }
 
-#include "G4NucleiPropertiesTable.hh"
+#include "G4NucleiProperties.hh"
 
 G4double G4NeutronHPCaptureData::
@@ -148,5 +156,7 @@
   G4double eKinetic = aP->GetKineticEnergy();
 
-  if ( getenv( "G4NEUTRONHP_NEGLECT_DOPPLER" ) )
+//if ( getenv( "G4NEUTRONHP_NEGLECT_DOPPLER" ) )
+//080428
+  if ( !onFlightDB )
   {
      G4double factor = 1.0;
@@ -171,6 +181,5 @@
   G4double theZ = anE->GetZ();
   G4double eleMass; 
-  eleMass = ( G4NucleiPropertiesTable::GetNuclearMass(static_cast<G4int>(theZ+eps), static_cast<G4int>(theA+eps))
-	     ) / G4Neutron::Neutron()->GetPDGMass();
+  eleMass = G4NucleiProperties::GetNuclearMass( static_cast<G4int>(theA+eps) , static_cast<G4int>(theZ+eps) ) / G4Neutron::Neutron()->GetPDGMass();
   
   G4ReactionProduct boosted;
Index: trunk/source/processes/hadronic/models/neutron_hp/src/G4NeutronHPCaptureFS.cc
===================================================================
--- trunk/source/processes/hadronic/models/neutron_hp/src/G4NeutronHPCaptureFS.cc	(revision 819)
+++ trunk/source/processes/hadronic/models/neutron_hp/src/G4NeutronHPCaptureFS.cc	(revision 962)
@@ -30,4 +30,5 @@
 // 12-April-06 Enable IC electron emissions T. Koi 
 // 26-January-07 Add G4NEUTRONHP_USE_ONLY_PHOTONEVAPORATION flag
+// 081024 G4NucleiPropertiesTable:: to G4NucleiProperties::
 //
 #include "G4NeutronHPCaptureFS.hh"
@@ -56,5 +57,5 @@
     G4double eps = 0.0001;
     if(targetMass<500*MeV)
-      targetMass = ( G4NucleiPropertiesTable::GetNuclearMass(static_cast<G4int>(theBaseZ+eps), static_cast<G4int>(theBaseA+eps))) /
+      targetMass = ( G4NucleiProperties::GetNuclearMass( static_cast<G4int>(theBaseA+eps) , static_cast<G4int>(theBaseZ+eps) )) /
                      G4Neutron::Neutron()->GetPDGMass();
     G4ThreeVector neutronVelocity = 1./G4Neutron::Neutron()->GetPDGMass()*theNeutron.GetMomentum();
Index: trunk/source/processes/hadronic/models/neutron_hp/src/G4NeutronHPChannel.cc
===================================================================
--- trunk/source/processes/hadronic/models/neutron_hp/src/G4NeutronHPChannel.cc	(revision 819)
+++ trunk/source/processes/hadronic/models/neutron_hp/src/G4NeutronHPChannel.cc	(revision 962)
@@ -30,4 +30,5 @@
 // 070523 bug fix for G4FPE_DEBUG on by A. Howard ( and T. Koi)
 // 071031 bug fix T. Koi on behalf of A. Howard 
+// 081203 bug fix in Register method by T. Koi
 //
 #include "G4NeutronHPChannel.hh"
@@ -68,8 +69,14 @@
     registerCount++;
     G4int Z = G4lrint(theElement->GetZ());
+
+    Z = Z-registerCount;
+    if ( registerCount > 5 ) throw G4HadronicException(__FILE__, __LINE__, "Channel: Do not know what to do with this material"); // for Elastic, Capture, Fission case 
+    if ( Z < 1 ) return false; 
+/*
     if(registerCount<5)
     {
       Z = Z-registerCount;
     }
+*/
     //if(Z=theElement->GetZ()-5) throw G4HadronicException(__FILE__, __LINE__, "Channel: Do not know what to do with this material");
     // Bug fix by TK on behalf of AH
@@ -84,4 +91,5 @@
     delete [] active;
     active = new G4bool[niso];
+
     delete [] theFinalStates;
     theFinalStates = new G4NeutronHPFinalState * [niso];
Index: trunk/source/processes/hadronic/models/neutron_hp/src/G4NeutronHPContAngularPar.cc
===================================================================
--- trunk/source/processes/hadronic/models/neutron_hp/src/G4NeutronHPContAngularPar.cc	(revision 819)
+++ trunk/source/processes/hadronic/models/neutron_hp/src/G4NeutronHPContAngularPar.cc	(revision 962)
@@ -32,4 +32,8 @@
 //        (This fix has a real effect to the code.) 
 // 080409 Fix div0 error with G4FPE by T. Koi
+// 080612 Fix contribution from Benoit Pirard and Laurent Desorgher (Univ. Bern) #1
+// 080714 Limiting the sum of energy of secondary particles by T. Koi
+// 080801 Fix div0 error wiht G4FPE and memory leak by T. Koi
+// 081024 G4NucleiPropertiesTable:: to G4NucleiProperties::
 //
 
@@ -46,5 +50,5 @@
 #include "G4Alpha.hh"
 #include "G4NeutronHPVector.hh"
-#include "G4NucleiPropertiesTable.hh"
+#include "G4NucleiProperties.hh"
 #include "G4NeutronHPKallbachMannSyst.hh"
 #include "G4ParticleTable.hh"
@@ -67,5 +71,5 @@
   G4ReactionProduct * 
   G4NeutronHPContAngularPar::Sample(G4double anEnergy, G4double massCode, G4double /*targetMass*/, 
-                                    G4int angularRep, G4int /*interpolE*/)
+                                    G4int angularRep, G4int interpolE )
   {
     G4ReactionProduct * result = new G4ReactionProduct;
@@ -110,4 +114,76 @@
     if(angularRep==1)
     {
+// 080612 Fix contribution from Benoit Pirard and Laurent Desorgher (Univ. Bern) #1
+	if (interpolE == 2)
+	{
+
+            //TK080711
+           if ( fresh == true ) 
+           { 
+              remaining_energy = theAngular[0].GetLabel();
+              fresh = false; 
+           }
+           //TK080711
+
+	   G4double random = G4UniformRand();
+	   G4double * running = new G4double[nEnergies+1];
+	   running[0]=0;
+
+	    for(i=1; i<nEnergies+1; i++)
+	    {
+               //TK080711
+               if ( remaining_energy >= theAngular[ i-1 ].GetLabel() ) 
+                  running[i] = running[i-1] + theAngular[i-1].GetValue(0);
+               else
+                  running[i] = running[i-1];
+               //TK080711
+	    }
+
+            //080730
+            if ( running[ nEnergies ] != 0 ) 
+            {
+
+	       for ( i = 1 ; i < nEnergies+1 ; i++ )
+	       {
+	 	it = i-1;
+		if ( random > running[ i-1 ]/running[ nEnergies ] && random <= running[ i ] / running[ nEnergies ] ) break;
+               }
+	       fsEnergy = theAngular[ it ].GetLabel();
+
+            }
+
+            //TK080711 
+            if ( i == nEnergies+1 || running[ nEnergies ] == 0 ) fsEnergy = remaining_energy;
+            //TK080711 //080730
+
+	    G4NeutronHPLegendreStore theStore(1);
+	    theStore.Init(0,fsEnergy,nAngularParameters);
+	    for(i=0;i<nAngularParameters;i++)
+	    {
+		theStore.SetCoeff(0,i,theAngular[it].GetValue(i));
+	    }
+	    // use it to sample.
+	    cosTh = theStore.SampleMax(fsEnergy);
+
+            //TK080711
+            remaining_energy -= fsEnergy;
+            //TK080711
+
+           //080801b
+	   delete[] running;
+           //080801b
+        }
+      else 
+      {
+
+            //080714 
+            if ( fresh == true )
+            {
+               remaining_energy = theAngular[ nEnergies-1 ].GetLabel();
+               fresh = false;
+            }
+            //080714 
+
+     
       G4double random = G4UniformRand();
       G4double * running = new G4double[nEnergies];
@@ -116,4 +192,5 @@
       for(i=1; i<nEnergies; i++)
       {
+/*
         if(i!=0) 
         {
@@ -126,20 +203,43 @@
                              theAngular[i-1].GetLabel(), theAngular[i].GetLabel(),
                              theAngular[i-1].GetValue(0), theAngular[i].GetValue(0));
+*/
+
+        running[i]=running[i-1];
+        if ( remaining_energy >= theAngular[i].GetLabel() )
+        {
+           running[i] += theInt.GetBinIntegral(theManager.GetScheme(i-1),
+                             theAngular[i-1].GetLabel(), theAngular[i].GetLabel(),
+                             theAngular[i-1].GetValue(0), theAngular[i].GetValue(0));
+           weighted += theInt.GetWeightedBinIntegral(theManager.GetScheme(i-1),
+                             theAngular[i-1].GetLabel(), theAngular[i].GetLabel(),
+                             theAngular[i-1].GetValue(0), theAngular[i].GetValue(0));
+        }
       }
       // cash the mean energy in this distribution
       //080409 TKDB
-      if ( nEnergies == 1 )  
+      if ( nEnergies == 1 || running[nEnergies-1] == 0 )  
          currentMeanEnergy = 0.0;
       else
+      { 
          currentMeanEnergy = weighted/running[nEnergies-1];
+      }
       
       //080409 TKDB
       if ( nEnergies == 1 ) it = 0; 
-      //for(i=1; i<nEnergies; i++)
-      for(i=1; i<nEnergies; i++)
-      {
-        it = i;
-        if(random<running[i]/running[nEnergies-1]) break;
-      }
+
+      //080729
+      if ( running[nEnergies-1] != 0 )  
+      {
+         for ( i = 1 ; i < nEnergies ; i++ )
+         {
+            it = i;
+            if ( random < running [ i ] / running [ nEnergies-1 ] ) break;
+         } 
+      }
+
+      //080714
+      if ( running [ nEnergies-1 ] == 0 ) it = 0;
+      //080714
+
       if(it<nDiscreteEnergies||it==0) 
       {
@@ -201,4 +301,11 @@
       }
       delete [] running;
+
+      //080714
+      remaining_energy -= fsEnergy;
+      //080714
+
+      }
+
     }
     else if(angularRep==2)
@@ -271,5 +378,5 @@
       G4double residualMass =  residualZ*G4Proton::Proton()->GetPDGMass();
                residualMass +=(residualA-residualZ)*G4Neutron::Neutron()->GetPDGMass();
-               residualMass -= G4NucleiPropertiesTable::GetBindingEnergy(residualZ, residualA);
+               residualMass -= G4NucleiProperties::GetBindingEnergy( residualA , residualZ );
       G4NeutronHPKallbachMannSyst theKallbach(compoundFraction,
                                               incidentEnergy, incidentMass,
Index: trunk/source/processes/hadronic/models/neutron_hp/src/G4NeutronHPContEnergyAngular.cc
===================================================================
--- trunk/source/processes/hadronic/models/neutron_hp/src/G4NeutronHPContEnergyAngular.cc	(revision 819)
+++ trunk/source/processes/hadronic/models/neutron_hp/src/G4NeutronHPContEnergyAngular.cc	(revision 962)
@@ -28,4 +28,7 @@
 // A prototype of the low energy neutron transport model.
 //
+// 080721 To be "ClearHistories" effective, the selection scheme of angular distribution is modified by T. Koi
+//
+//
 #include "G4NeutronHPContEnergyAngular.hh"
 
@@ -55,8 +58,10 @@
      // This is the cause of the He3 problem !!!!!!!!
      // See to it, if you can improve this.
-     G4double random = G4UniformRand();
-     G4double deltaE = theAngular[it].GetEnergy()-theAngular[it-1].GetEnergy();
-     G4double offset = theAngular[it].GetEnergy()-anEnergy;
-     if(random<offset/deltaE) it--; 
+     //080714 TK commnet Randomizing use angular distribution
+     //080714 TK Always use the upper side distribution. enabling ClearHistories method.
+     //G4double random = G4UniformRand();
+     //G4double deltaE = theAngular[it].GetEnergy()-theAngular[it-1].GetEnergy();
+     //G4double offset = theAngular[it].GetEnergy()-anEnergy;
+     //if(random<offset/deltaE) it--;
      theAngular[it].SetTarget(GetTarget());
      theAngular[it].SetTargetCode(theTargetCode);
@@ -84,2 +89,13 @@
    return result;
 }
+
+
+ 
+void G4NeutronHPContEnergyAngular::ClearHistories()
+{ 
+   if ( theAngular!= NULL )
+   { 
+      for ( G4int i = 0 ; i< nEnergy ; i++ ) 
+         theAngular[i].ClearHistories(); 
+   } 
+}
Index: trunk/source/processes/hadronic/models/neutron_hp/src/G4NeutronHPDeExGammas.cc
===================================================================
--- trunk/source/processes/hadronic/models/neutron_hp/src/G4NeutronHPDeExGammas.cc	(revision 819)
+++ trunk/source/processes/hadronic/models/neutron_hp/src/G4NeutronHPDeExGammas.cc	(revision 962)
@@ -27,4 +27,6 @@
 // J.P. Wellisch, Nov-1996
 // A prototype of the low energy neutron transport model.
+//
+// 080801 Prohibit level transition to oneself by T. Koi
 //
 #include "G4NeutronHPDeExGammas.hh"
@@ -123,4 +125,13 @@
       }
     }
+//080728
+    if ( it != -1 && currentLevelE == theLevels[it].GetLevelEnergy() )
+    {
+       //TK Comment; Some data file in /Inelastic/Gammas has inconsistent level data (no level to transit)
+       //G4cout << "DeExGammas Transition level error: it " << it << " " << currentLevelE << " " << gammaE << " " << theLevels[it-1].GetLevelEnergy() << " " << currentLevelE - theLevels[it-1].GetLevelEnergy() << G4endl;
+       // Forced to connect the next(previous) level 
+       it +=-1;
+    }
+//080728
     if(it!=-1) theGammas[i]->SetNext(&theLevels[it]);
   }
